# mypy-boto3-lakeformation

[![PyPI - mypy-boto3-lakeformation](https://img.shields.io/pypi/v/mypy-boto3-lakeformation.svg?color=blue)](https://pypi.org/project/mypy-boto3-lakeformation)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-lakeformation.svg?color=blue)](https://pypi.org/project/mypy-boto3-lakeformation)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.LakeFormation 1.16.17](https://boto3.amazonaws.com/v1/documentation/api/1.16.17/reference/services/lakeformation.html#LakeFormation) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 3.2.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-lakeformation](#mypy-boto3-lakeformation)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `LakeFormation` service.

```bash
python -m pip install boto3-stubs[lakeformation]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[lakeformation]` in your environment: `python -m pip install 'boto3-stubs[lakeformation]'`

Both type checking and auto-complete should work for `LakeFormation` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[lakeformation]` in your environment: `python -m pip install 'boto3-stubs[lakeformation]'`

Both type checking and auto-complete should work for `LakeFormation` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[lakeformation]` in your environment: `python -m pip install 'boto3-stubs[lakeformation]'`
- Run `mypy` as usual

Type checking should work for `LakeFormation` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[lakeformation]` in your environment: `python -m pip install 'boto3-stubs[lakeformation]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `LakeFormation` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`LakeFormationClient` provides annotations for `boto3.client("lakeformation")`.

```python
import boto3

from mypy_boto3_lakeformation import LakeFormationClient

client: LakeFormationClient = boto3.client("lakeformation")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: LakeFormationClient = session.client("lakeformation")
```








### Typed dictionations

`mypy_boto3_lakeformation.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_lakeformation.type_defs import (
    BatchGrantPermissionsResponseTypeDef,
    BatchPermissionsFailureEntryTypeDef,
    BatchPermissionsRequestEntryTypeDef,
    BatchRevokePermissionsResponseTypeDef,
    ColumnWildcardTypeDef,
    DatabaseResourceTypeDef,
    DataLakePrincipalTypeDef,
    DataLakeSettingsTypeDef,
    DataLocationResourceTypeDef,
    DescribeResourceResponseTypeDef,
    DetailsMapTypeDef,
    ErrorDetailTypeDef,
    FilterConditionTypeDef,
    GetDataLakeSettingsResponseTypeDef,
    GetEffectivePermissionsForPathResponseTypeDef,
    ListPermissionsResponseTypeDef,
    ListResourcesResponseTypeDef,
    PrincipalPermissionsTypeDef,
    PrincipalResourcePermissionsTypeDef,
    ResourceInfoTypeDef,
    ResourceTypeDef,
    TableResourceTypeDef,
    TableWithColumnsResourceTypeDef,
)

def get_structure() -> BatchPermissionsFailureEntryTypeDef:
    return {
      ...
    }
```
